# Dockerfiles de Picasoft

Ce dépôt centralise les Dockerfiles et autre ressources utilisées pour construire **et** déployer les images Docker tournant en production sur l'infrastructure de Picasoft.

## Contenu du dépôt

Ce dépôt contient toutes les ressources permettant de déployer les services que nous maintenons sur n'importe quelle machine virtuelle de l'infrastructure de Picasoft, sans prérequis.

Cela signifie que le bon fonctionnement d'un service n'est pas dépendant de la machine virtuelle sur laquelle on essaye de le lancer (en adéquation avec la philosophie Docker).

Ainsi, chaque service versionné sur ce dépôt contiendra :

* Un `Dockerfile` permettant de construire l'image,
* Un fichier `docker-compose.yml` permettant de lancer le service,
* Si possible, un ou des fichiers de configuration permettant de personnaliser le service selon nos besoins,
* Un fichier d'exemple de secrets (mot de passe...) nécessaire au lancement du service,
* Un `README.md` résumant les paramètres modifiables sur le dépôt, les mécanismes pour en rajouter, etc,
* Pour les images maison, un `CHANGELOG.md` résumant les modifications faites au fil des version.

Il n'y a pas de Docker Compose global : chaque service a son propre Docker Compose.

Un exemple concret peut être trouvé au niveau de [pica-mattermost](./pica-mattermost) ou [pica-etherpad](./pica-etherpad).

## Mais je commence par où, bordel ?

On peut vite se perdre sur ce dépôt, en fonction de ce que l'on veut faire.

### Je veux lancer un service existant sur une machine virtuelle

Si le service que vous souhaitez lancer est référencé sur ce dépôt, la documentation pour le tester et le déployer se trouve [ici](./doc/guide_deploiement.md).

### Je veux mettre à jour un service

Il faut pour cela utiliser la chaîne d'intégration de ce dépôt, qui construit automatiquement les images Docker. La documentation utilisateur se trouve [ici](./doc/guide_utilisateur_ci.md).

### Je veux mettre en place un nouveau service

Il faudra d'une part respecter les conventions utilisées par la chaîne d'intégration, qui sont disponibles [ici](./doc/guide_developpeur_ci.md#formalisme-du-dpt).

Ensuite, il faudra jeter un oeil [aux bonnes pratiques](./doc/guide_bonnes_pratiques.md) à l'oeuvre sur l'infrastructure de Picasoft.

Un dossier [template](./template) prêt à copier est aussi disponible.

### Je veux améliorer la chaîne d'intégration

Il existe une documentation "développeur" pour la chaîne d'intégration, qui rentre plus en détail, disponible [ici](./doc/guide_developpeur_ci.md).
